#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define FOR(i, n) for (i = 0; i < n; i++)
#define GETI(i) scanf(" %d", &i);
#define ODL(x1, x2, y1, y2) ( (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) )

int n;
bool e[512][512];
int wyn[512];
int wyn2[512];
int il1[512];
int il2[512];
vector< pair<int, pair<int, int> > > odl;
int x1[512];
int x2[512];
int y1[512];
int y2[512];

void rek2(int);

void rek1(int i) {
	int j;
	FOR(j, n) if (e[i][j]) break;
	wyn[i] = j;
	e[i][j] = false; il1[i]--; il2[j]--;
	FOR(i, n) if (e[i][j]) {
		e[i][j] = false; il1[i]--; il2[j]--;
		if (il1[i] == 1) rek1(i);
	}
}

void rek2(int j) {
	int i;
	FOR(i, n) if (e[i][j]) break;
	wyn[i] = j;
	e[i][j] = false; il1[i]--; il2[j]--;
	FOR(j, n) if (e[i][j]) {
		e[i][j] = false; il1[i]--; il2[j]--;
		if (il2[j] == 1) rek2(j);
	}
}

int main() {
	int N, i, j, k;
	
	GETI(N);
	while(N--) {
		GETI(n);
		odl.resize(n*n);
		FOR(i, n) {
			il1[i] = n;
			GETI(x1[i]);
			GETI(y1[i]);
		}
		FOR(i, n) {
			il2[i] = n;
			GETI(x2[i]);
			GETI(y2[i]);
		}
		k = 0;
		FOR(i, n) FOR(j, n) {
			e[i][j] = true;
			odl[k++] = make_pair(ODL(x1[i], x2[j], y1[i], y2[j]), make_pair(i, j));
		}
		sort(odl.begin(), odl.end());
		//FOR(i, n*n) printf("%d\n", odl[i].first);
		if (n < 2) {
			wyn[0] = 0;
		} else
		for (k = n*n-1; k >= 0; k--) {
			//printf("%d\n", odl[k].first);
			i = odl[k].second.first;
			j = odl[k].second.second;
			if (! e[i][j]) continue;
			e[i][j] = false; il1[i]--; il2[j]--;
			if (il1[i] == 1) rek1(i);
			if (il2[j] == 1) rek2(j);
		}
		FOR(i, n) {
			if (i) printf(" ");
			printf("%d", wyn[i] + 1);
			wyn2[wyn[i]] = i;
		}
		printf("\n");
		FOR(i, n) {
			if (i) printf(" ");
			printf("%d", wyn2[i] + 1);
		}
		printf("\n");
		if (N) printf("\n");
	}
	return 0;
}

