#include <iostream>
#include <set>
#include <vector>
#include <list>
#include <string>

using namespace std;

int prz1[10], prz3[10];
string prz2[10], prz4[10];

int lower[10][10];

struct tprz {
    long double p;
    string name;
    tprz(const string &n = "", int pp = 0) { name = n; p = pp; }
    bool operator<(const tprz &prz) const
    {
        return name < prz.name;
    }
};

set<tprz> przel;
int N;

struct twzo {
    long double len;
    string name;
    bool operator<(const twzo &w) const {
        return len < w.len;
    }
    bool operator>(const twzo &w) const {
        return len > w.len;
    }
};


vector<twzo> wzorce;

long double przelicz(int a,string &p1, string &p2)
{
    return a * przel.find(p1)->p / przel.find(p2)->p;
}


int prz;

long double przelicznik(const string &a)
{
    int i;
//    cout << "licze " << a << endl;
    for (i = 0;i < prz;i++) {
        if (prz2[i] == a) 
            return prz3[i] * przelicznik(prz4[i]);
    }
    return 1;
}

int i,j,k,l;

int main()
{
    cin >> N;
    while (N-- > 0) {
        // przeliczniki
        cin >> prz;
        przel.clear();
        int lowest = -1;
        for (i = 0;i < prz;i++) {
            for (j = 0;j < prz;j++) lower[i][j] = -1;
        }
        for (i = 0;i < prz;i++) {
            char cc[10];
            cin >> prz1[i] >> prz2[i] >>  cc >>prz3[i] >> prz4[i];
            if (przel.find(tprz(prz2[i])) == przel.end()) {
                przel.insert(tprz(prz2[i]));
            }
            if (przel.find(tprz(prz4[i])) == przel.end()) {
                przel.insert(tprz(prz4[i]));
            }
        }
//        cout << "dupa" << endl;
        int counted = 0;
        while (counted < przel.size()) {
        for (set<tprz>::iterator it = przel.begin();it != przel.end();it++) {
            
            if (it->p > 0) continue;
//            cout << "mam " << it->name << endl;
            tprz pp = *it;
            przel.erase(it);
            pp.p = przelicznik(it->name);
            przel.insert(pp);
//            cout << pp.name << " = " << pp.p << endl;
            counted++;
            break;
        }
        }
    
        cin >> j;
        for (i = 0;i < j;i++) {
            string ppp;
            char li[100];
            twzo w;
            int l;
            cin >> l >> ppp;
            sprintf(li, "%i", l);
            w.name = string(li) + " " + ppp;
            w.len = przel.find(ppp)->p * l;
            wzorce.push_back(w);
//           cout << "wzorzec " << w.name << " ma dlugosc " << w.len << endl; 
        }
        sort(wzorce.begin(), wzorce.end());
        for (i = 0;i < wzorce.size();i++) {
//            cout << "wz " << wzorce[i].name << " " << wzorce[i].len << endl;
        }
        cin >> j;
        for (i = 0;i < j;i++) {
            string ppp;
            int l;
            long double ll;
            cin >>  l >> ppp;
            ll = l * przel.find(ppp)->p;

            vector<twzo>::iterator lb;
            twzo ss;
            ss.len = ll;
//            cout << "szukam " << ppp << "(" << ss.len << ")" << endl;
            lb = lower_bound(wzorce.begin(), wzorce.end(), ss);
            if (lb == wzorce.end()) lb = wzorce.end()-1;
            if (lb->len == ll) ; 
            else if (lb->len > ll && lb != wzorce.begin()) { 
                if (abs(lb->len - ll) >= abs((lb-1)->len - ll)) {
                    lb = lb-1;
                }
                if (lb->len > ll && lb != wzorce.begin()) { 
                 if (abs(lb->len - ll) >= abs((lb-1)->len - ll)) {
                    lb = lb-1;
                }
                }
            }
            cout << lb->name << endl;
        }
    }
/*        
        for (i = 0;i < prz;i++) {
            for (j = 0;j < prz;j++) {
                if (i != j && lower[i][j] == -1) {
                    for (k = 0; k < prz;k++) {
                        if (lower[i][k] == 0) 
                }
            }
                        
        }

            
    }
    */
    return 0;
}

